# Obx


- [English Document](./README.md)
- [中文文档](./README-CN.md)

Obx is **tiny \ fast \ simple** state manage.

- Obx not need Provider at root Widget.
- Obx use `memo` to intercept update, like react.Hooks.
- Obx is tiny and ease use, only 2 API:
  - ob
  - next


## All in the picture

Definition User:

![](carbon_user.png)

Import user.dart:

![](carbon_page.png)

## Overall interpretation

Instance a `user`，extends `Obx`:

```dart
// Definition Obx
class User extends Obx {
  String name = "dog";
}

// Instance, use some widgets
var user = User();
```

Subscribe and return a weight:

```dart
user.ob(()=>Text(user.name))
```

Submit and update user.ob's subscribe:

```dart
user.next()
```


### Install Obx

Change `pubspec.yaml`:

```yaml
dependencies:
  obx:
```


## Better performance


Use `memo` options params, like `React.useMemo`, only rerender data in memo array.

Example only rerender when user.name change:

```dart
user.ob(
  () => Text(user.name), 
  memo: ()=>[user.name],
);
```

That all, keep sample :)